{
  inputs = {
    nixpkgs.url = github:NixOS/nixpkgs;
    oxalica.url = github:oxalica/rust-overlay;
  };

  outputs = { nixpkgs, oxalica, ... }: let
    pkgs = import nixpkgs { system = "x86_64-linux"; overlays = [(import oxalica)]; };
  in{
    devShell."x86_64-linux" = pkgs.mkShell {
      buildInputs = with pkgs; 
      let rust = (rust-bin.selectLatestNightlyWith (toolchain: toolchain.default.override {
            extensions = [ "rust-src" "rustfmt" "rust-analyzer" ];
          }));
      in [
        rust
        openssl
        pkg-config
        evcxr
        llvmPackages_16.clang
        llvmPackages_16.libclang
      ];

      shellHook = ''
        export LIBCLANG_PATH="${pkgs.llvmPackages_16.libclang.lib}/lib";
      '';
    };
  };
}
